@echo off
color 0A
cls
SETLOCAL ENABLEEXTENSIONS

set ver1=17.1
set ver2=1710i-u
set ver3=202409091710

set ver=0
ver | find "5.1"
if %ERRORLEVEL%==0 set ver=51
ver | find "6.0"
if %ERRORLEVEL%==0 set ver=60
ver | find "6.1"
if %ERRORLEVEL%==0 set ver=70
ver | find "6.2"
if %ERRORLEVEL%==0 set ver=80
ver | find "6.3"
if %ERRORLEVEL%==0 set ver=81
ver | find "10.0"
if %ERRORLEVEL%==0 set ver=100
ver | find "10.0.2"
if %ERRORLEVEL%==0 set ver=110

if %ver% LSS 60 (set ver=xp) && goto next
if %ver% GTR 70 if not exist "%ProgramFiles%\Windows Sidebar\8GadgetPack.exe" (set ver=no8) && goto next

set installdir=%USERPROFILE%\AppData\Local\Microsoft\Windows Sidebar\Gadgets
if not exist "%installdir%" (set ver=xp) && goto next 

if exist "%installdir%\PHSM-Calendar1.gadget" rmdir /s /q "%installdir%\PHSM-Calendar1.gadget"

set installdir=%installdir%\PHSM-Calendar.gadget

if exist "%installdir%\da-DK\BrowserSupport\*.lnk" del /q "%installdir%\da-DK\BrowserSupport\*.lnk"
if exist "%installdir%\en-US\BrowserSupport\*.lnk" del /q "%installdir%\en-US\BrowserSupport\*.lnk"

set folder=ok
echo %~dp0 | find /i "%TEMP%" > nul
if %ERRORLEVEL%==0 set folder=temp
echo %~dp0 | find "\\" > nul
if %ERRORLEVEL%==0 set folder=share
if not %folder%==ok goto next

set file=ok
if not exist unzip.exe (set file=unzip.exe) & goto next
if not exist PHSM-Calendar.gadget if exist PHSM-Calendar%ver2%.zip unzip -oqqq PHSM-Calendar%ver2%.zip PHSM-Calendar.gadget
if not exist touch.exe if exist PHSM-Calendar%ver2%.zip unzip -oqqq PHSM-Calendar%ver2%.zip touch.exe
rem if not exist touch.exe set file=touch.exe
if not exist PHSM-Calendar.gadget set file=PHSM-Calendar.gadget

:next
REG QUERY "HKCU\Control Panel\International" /v "locale" | find "0406"
if %ERRORLEVEL%==0 goto dansk

cls
echo.
echo               -- Updating of PHSM-Calendar to version %ver1% --
echo.
if %ver%==xp goto err0_e
if %ver%==no8 goto err1_e
if %folder%==temp goto err2_e
if %folder%==share goto err3_e
if not %file%==ok goto err4_e

if exist "%installdir%" goto update_e
echo.
echo Do you want to install the PHSM-Calendar Gadget on this
echo Computer for this User account?
echo.
CHOICE /C YN /N /M "Confirm [Y/N]?"
if not %ERRORLEVEL%==1 goto end_e

echo.
echo.
echo Ignore the warning about missing verification of publisher and
echo click the Install button in the dialog box that has been opened.
explorer PHSM-Calendar.gadget
goto end_e

:update_e
echo.
echo Do you wish to update your current PHSM-Calendar installation
echo preserving your settings.
echo.
CHOICE /C YN /N /M "Confirm [Y/N]?"
if not %ERRORLEVEL%==1 goto end_e

echo.
echo.
echo Unpacking files . . .
echo.
if exist "%installdir%\en-US\PHSM-Dates.txt" copy /y "%installdir%\en-US\PHSM-Dates.txt" "%TEMP%\PHSM-Dates.txt" > nul
unzip -oDDq PHSM-Calendar.gadget -x en-US\PHSM-Dates.txt -d "%installdir%"
if %ERRORLEVEL%==50 (echo.) & (echo     Click on the PHSM-Calendar on the Desktop and run update.cmd again!)
if %ERRORLEVEL%==0 (set end=done_e) else set end=end_e
if exist touch.exe touch -cmsq -t %ver3% -- "%installdir%"
if exist "%TEMP%\PHSM-Dates.txt" move /y "%TEMP%\PHSM-Dates.txt" "%installdir%\en-US\PHSM-Dates.txt" > nul
goto %end%

:err0_e
echo.
echo This update cannot be run under Windows XP or older.
echo.
echo See the readme-en.txt file about how to install under Windows XP.
goto end_e

:err1_e
echo.
echo You need to have 8GadgetPack installed to be able to run the
echo the PHSM-Calendar gadget.
echo.
echo You can download 8GadgetPack here: https://8gadgetpack.net
goto end_e

:err2_e
echo.
echo Cannot run unzip.exe from inside the PHSM-Calendar%ver2%.zip file.
echo.
echo Unpack the PHSM-Calendar%ver2%.zip file and run update.cmd again.
goto end_e

:err3_e
echo.
echo Cannot run unzip.exe from a Network share.
echo.
echo Unpack the PHSM-Calendar%ver2%.zip file to a local drive
echo and run update.cmd again.
goto end_e

:err4_e
echo.
echo Cannot find the file %file%
echo.
echo Unpack %file% from the PHSM-Calendar%ver2%.zip file
echo and run update.cmd again.
goto end_e

:done_e
echo Done
echo.
echo.
echo     Click on the PHSM-Calendar and press F5 to restart the calendar.
echo     Note - the PHSM-Calendar must be maximized when F5 is pressed.

:end_e
echo.
echo.
echo Press any key to finish . . .
pause > nul
goto end



:dansk
cls
echo.
echo               -- Opdatering af PHSM-Kalender til version %ver1% --
echo.
if %ver%==xp goto err0_d
if %ver%==no8 goto err1_d
if %folder%==temp goto err2_d
if %folder%==share goto err3_d
if not %file%==ok goto err4_d

if exist "%installdir%" goto update_d
echo.
echo nsker du at installere PHSM-Kalender Gadget p denne
echo Computer for denne Brugerkonto?
echo.
CHOICE /C JN /N /M "Bekrft [J/N]?"
if not %ERRORLEVEL%==1 goto end_d

echo.
echo.
echo Ignorer advarslen om manglende bekrftelse af udgiver, og klik
echo p knappen Installer i den dialogboks, som er blevet bnet.
explorer PHSM-Calendar.gadget
goto end_d

:update_d
echo.
echo Vil du opdatere din nuvrende PHSM-Kalender installation og
echo bevare dine indstillinger.
echo.
CHOICE /C JN /N /M "Bekrft [J/N]?"
if not %ERRORLEVEL%==1 goto end_d

echo.
echo.
echo Udpakker filer . . .
echo.
if exist "%installdir%\da-DK\PHSM-Dates.txt" copy /y "%installdir%\da-DK\PHSM-Dates.txt" "%TEMP%\PHSM-Dates.txt" > nul
unzip -oDDq PHSM-Calendar.gadget -x da-DK\PHSM-Dates.txt -d "%installdir%"
if %ERRORLEVEL%==50 (echo.) & (echo     Klik p PHSM-Kalenderen p Skrivebordet og kr update.cmd igen!)
if %ERRORLEVEL%==0 (set end=done_d) else set end=end_d
if exist touch.exe touch -cmsq -t %ver3% -- "%installdir%"
if exist "%TEMP%\PHSM-Dates.txt" move /y "%TEMP%\PHSM-Dates.txt" "%installdir%\da-DK\PHSM-Dates.txt" > nul
goto %end%

:err0_d
echo.
echo Denne opdatering kan ikke kres under Windows XP eller ldre.
echo.
echo Se readme-da.txt filen om hvordan der kan installeres under Windows XP.
goto end_d

:err1_d
echo.
echo Det er ndvendigt at have 8GadgetPack installeret for at
echo kunne kre PHSM-Calendar gadget.
echo.
echo Du kan downloade 8GadgetPack her: https://8gadgetpack.net
goto end_d

:err2_d
echo.
echo Kan ikke kre unzip.exe inde fra PHSM-Calendar%ver2%.zip filen.
echo.
echo Udpak PHSM-Calendar%ver2%.zip filen og kr update.cmd igen.
goto end_d

:err3_d
echo.
echo Kan ikke kre unzip.exe fra et delt Netvrksdrev.
echo.
echo Udpak PHSM-Calendar%ver2%.zip filen til et lokalt drev
echo og kr update.cmd igen.
goto end_d

:err4_d
echo.
echo Kan ikke finde filen %file%
echo.
echo Udpak %file% fra PHSM-Calendar%ver2%.zip filen
echo og kr update.cmd igen.
goto end_d

:done_d
echo Udfrt
echo.
echo.
echo     Klik p PHSM-Kalender og tryk F5 for at genstarte kalenderen.
echo     Obs - PHSM-Kalender skal vre maksimeret, nr der trykkes F5.

:end_d
echo.
echo.
echo Tryk p en vilkrlig tast for at afslutte . . .
pause > nul

:end
ENDLOCAL
